// *********************************************************************
//  Created with bc9Basic - BASIC To C/C++ Translator (V) 9.2.4.9 (2016/03/28)
//       The bc9Basic translator (bc9.exe) was compiled with
//                           g++ (tdm64-1) 5.1.0
// ----------------------------------------------------------------------
//                 BCX (c) 1999 - 2009 by Kevin Diggins
// *********************************************************************
//              Translated for compiling with a C++ Compiler
//                           On MS Windows
//                    Using TCLib by Fred Harris
// *********************************************************************
#ifndef UNICODE
#define UNICODE
#endif
#ifndef _UNICODE
#define _UNICODE
#endif
#define _X(y) y
#include <windows.h>
#define   x64
#include "TCLib\stdio.h"
#include "TCLib\string.h"
#include "TCLib\stdlib.h"
#include "TCLib\memory.h"
#include "TCLib\malloc.h"
#include "TCLib\tchar.h"
#include "TCLib\Strings.cpp"
extern _X("C") int _fltused = 1;
typedef String fstring;

// NO HEADERS START
#ifndef _WINDOWS_
//<---UNICODE AWARE
typedef _TCHAR *PCHAR, *LPCH, *PCH, *NPSTR, *LPSTR, *PSTR;
typedef unsigned long DWORD, *PDWORD, *LPDWORD;
typedef unsigned int UINT;
//>---UNICODE AWARE
#endif
// NO HEADERS END
// ***************************************************
// Compiler Defines
// ***************************************************
#ifndef __cplusplus
#error A C++ compiler is required
#endif
// $HEADER BEGIN
#define PropGet(p,t) const t& p() const {return m_##p;}
#define PropSet(p,t) void p(const t& param_##p){m_##p=param_##p;}
// $HEADER END


// *************************************************
//        User's GLOBAL ENUM blocks
// *************************************************

// *************************************************
//            System Defined Constants
// *************************************************

typedef const _TCHAR* ccptr;
#define CCPTR const _TCHAR*
#define cfree free
//<---UNICODE AWARE
typedef char _char;
#define _strlen strlen
//>---UNICODE AWARE
#define EQU ==
#define NOT_USED(x) if(x);
#define CTLHNDL(id) GetDlgItem(hWnd,id)
_TCHAR   *g_cptr_;  // dummy var for not used returns
unsigned int  g_dum1_;  // dummy var for not used returns
#define cSizeOfDefaultString 2048

// *************************************************
//            User Defined Constants
// *************************************************

#define PropGetSet(p,t) PropGet(p,t)PropSet(p,t)
#define ALI_ERROR_MEMORY 1
#define ALI_ERROR_FNF 2
#define ALI_ERROR_MAPPING 3
#define ALI_INVALID_HANDLE - 1

// *************************************************
//               Standard Prototypes
// *************************************************

void    Pause (void);
// *************************************************
//          User Defined Types, Unions and Classes
// *************************************************


class cAliInput
{
public:
    cAliInput(void);
    ~cAliInput(void);
    PropGet(iErr, int);
    PropGet(sErr, fstring);
    int   LineInput(fstring&);
    int   Open(fstring);
    void   Close(void);

protected:
    _TCHAR     m_nm[MAX_PATH] = {0};
    int      m_sz = {0};
    int      m_isEof = {0};
    int      m_nCharDone = {0};
    void*    m_pData = {0};
    HANDLE   m_hSys = {0};
    HANDLE   m_hFileMapping = {0};
    _char*   m_pSrc = {0};
    int      m_iErr = {0};
    fstring  m_sErr = {0};
};


// *************************************************
//            User Global Variables
// *************************************************

static _TCHAR*   *g_argv;
static int     g_argc;


// *************************************************
//               User Prototypes
// *************************************************

int     _tmain (void);

// *************************************************
//            User Global Initialized Arrays
// *************************************************



// *************************************************
//                 Runtime Functions
// *************************************************

void Pause(void)
{
    _tprintf(_T("\n%ls\n"), _T("Press any key to continue..."));
    _gettchar();
}



// *************************************************
//       User Subs, Functions and Class Methods
// *************************************************

void cAliInput::Close ()
{
    UnmapViewOfFile(m_pData);
    CloseHandle(m_hFileMapping);
    CloseHandle(m_hSys);
}


int cAliInput::LineInput (fstring&  sData)
{
    int      bInRecord = {0};
    int      iLen = {0};
    int      iResult = TRUE;
    _char*   dwStart = {0};
    fstring  fs1 = {0};
    for(;;)
    {
        if(m_nCharDone >= m_sz )
        {
            iResult = FALSE;
            m_isEof = TRUE;
            goto L1000;
        }
        if(*m_pSrc == 10 || *m_pSrc == 13 )
        {
            if(bInRecord )
            {
                goto L1000;
            }
            if(*m_pSrc == 10 && *(m_pSrc + 1) == 13 )
            {
                m_pSrc += 2;
                m_nCharDone += 2;
                bInRecord = TRUE;
                dwStart = m_pSrc;
                iLen++;
                sData = L"";
                return TRUE;
            }
        }
        else // case else
        {
            if(bInRecord )
            {
                iLen++;
            }
            else
            {
                bInRecord = TRUE;
                dwStart = m_pSrc;
                iLen++;
            }
        }
        m_pSrc++;
        m_nCharDone++;
    }
L1000:
    ;
    if(dwStart && iLen > 0 )
    {
        wchar_t*  wszTo = new wchar_t[iLen + 1];
        wszTo[iLen] = L'\0';
        MultiByteToWideChar(CP_ACP, 0, (LPCCH)dwStart, -1, wszTo, iLen);
        sData = wszTo;
        delete[] wszTo;
    }
    return iResult;
}


cAliInput::~cAliInput ()
{
    this->Close();
}
cAliInput::cAliInput ()
{
}
int cAliInput::Open (fstring  sFile)
{
    WIN32_FIND_DATA  w32 = {0};
    HANDLE   hSearch = {0};
    hSearch = FindFirstFile( sFile.lpStr(),  &w32);
    if(hSearch == INVALID_HANDLE_VALUE )
    {
        m_iErr = ALI_ERROR_FNF;
        m_sErr = _T("Unable to locate file ");
        m_sErr += sFile;
        return ALI_ERROR_FNF;
    }
    else
    {
        m_sz = w32.nFileSizeLow;
        CloseHandle(hSearch);
    }
    m_hSys = CreateFile( sFile.lpStr(), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
    if(m_hSys )
    {
        m_hFileMapping = CreateFileMapping( m_hSys, NULL, PAGE_READONLY, NULL, NULL, NULL);
        if(!m_hFileMapping )
        {
            CloseHandle(m_hSys);
            m_iErr = ALI_ERROR_MAPPING;
            m_sErr = _T("Unable to map file ");
            m_sErr += sFile;
            CloseHandle(m_hSys);
            return ALI_ERROR_MAPPING;
        }
        else
        {
            m_pData = MapViewOfFile( m_hFileMapping, FILE_MAP_READ, NULL, NULL, NULL);
            m_nCharDone = 0;
//<---UNICODE AWARE
            m_pSrc = ( char*) m_pData;
//>---UNICODE AWARE
            m_isEof = FALSE;
        }
    }
    else
    {
        m_iErr = ALI_ERROR_FNF;
        m_sErr = _T("Unable to open file ");
        m_sErr += sFile;
        return ALI_ERROR_FNF;
    }
    return 0;
}
int _tmain ()
{
    cAliInput*  cai;
    int      retval = {0};
    fstring  sFile(_T("cMMF2.CPP"));
    fstring  fsErr = {0};
    fstring  sData = {0};
    cai = new  cAliInput;
    retval = cai->Open( sFile);
    if(retval )
    {
        fsErr = cai->sErr();
        fsErr.Print( true);
    }
    else
    {
        while(cai->LineInput(sData))
        {
            _tprintf(_T("%ls\n"), sData.lpStr());
        }

    }
    Pause();
    delete cai;
}



